<?php
class ControllerExtensionPaymentFishpayWx extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/payment/fishpay_wx');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');
        $data['pay_code'] = 'fishpay_wx';

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('payment_'.$data['pay_code'], $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
		}



		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['app_id'])) {
			$data['error_app_id'] = $this->error['app_id'];
		} else {
			$data['error_app_id'] = '';
		}

		if (isset($this->error['error_app_key'])) {
			$data['error_app_key'] = $this->error['error_app_key'];
		} else {
			$data['error_app_key'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/payment/fishpay_wx', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['action'] = $this->url->link('extension/payment/fishpay_wx', 'user_token=' . $this->session->data['user_token'], true);

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);

		if (isset($this->request->post['payment_fishpay_wx_app_id'])) {
			$data['payment_fishpay_wx_app_id'] = $this->request->post['payment_fishpay_wx_app_id'];
		} else {
			$data['payment_fishpay_wx_app_id'] = $this->config->get('payment_fishpay_wx_app_id');
		}

		if (isset($this->request->post['payment_fishpay_wx_app_key'])) {
			$data['payment_fishpay_wx_app_key'] = $this->request->post['payment_fishpay_wx_app_key'];
		} else {
			$data['payment_fishpay_wx_app_key'] = $this->config->get('payment_fishpay_wx_app_key');
		}



		if (isset($this->request->post['payment_fishpay_wx_total'])) {
			$data['payment_fishpay_wx_total'] = $this->request->post['payment_fishpay_wx_total'];
		} else {
			$data['payment_fishpay_wx_total'] = $this->config->get('payment_fishpay_wx_total');
		}

		if (isset($this->request->post['payment_fishpay_wx_order_status_id'])) {
			$data['payment_fishpay_wx_order_status_id'] = $this->request->post['payment_fishpay_wx_order_status_id'];
		} else {
			$data['payment_fishpay_wx_order_status_id'] = $this->config->get('payment_fishpay_wx_order_status_id');
		}

		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post['payment_fishpay_wx_geo_zone_id'])) {
			$data['payment_fishpay_wx_geo_zone_id'] = $this->request->post['payment_fishpay_wx_geo_zone_id'];
		} else {
			$data['payment_fishpay_wx_geo_zone_id'] = $this->config->get('payment_fishpay_wx_geo_zone_id');
		}

		$this->load->model('localisation/geo_zone');

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

        $status_field = 'payment_'.$data['pay_code'].'_status';
        $data['status_field'] = $status_field;
        if (isset($this->request->post[$status_field])) {
            $data[$status_field] = $this->request->post[$status_field];
        } else {
            $data[$status_field] = $this->config->get($status_field);
        }

        $sort_order_field = 'payment_'.$data['pay_code'].'_sort_order';
        $data['sort_order_field'] = $sort_order_field;
        if (isset($this->request->post[$sort_order_field])) {
            $data[$sort_order_field] = $this->request->post[$sort_order_field];
        } else {
            $data[$sort_order_field] = $this->config->get($sort_order_field);
        }

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');
		$this->response->setOutput($this->load->view('extension/payment/fishpay_wx', $data));
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'extension/payment/fishpay_wx')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->request->post['payment_fishpay_wx_app_id']) {
			$this->error['error_app_id'] = $this->language->get('error_app_id');
		}

		if (!$this->request->post['payment_fishpay_wx_app_key']) {
			$this->error['error_app_key'] = $this->language->get('error_app_key');
		}

		return !$this->error;
	}
}