<?php
class ControllerExtensionPaymentFishpayWx extends Controller {
	public function index() {
		$data['button_confirm'] = $this->language->get('button_confirm');

		$this->load->model('checkout/order');

		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

		$config = array (
            'gateway_url' => 'https://grant.damicms.com/pay/index',
			'app_id'               => $this->config->get('payment_fishpay_wx_app_id'),
			'app_key' => $this->config->get('payment_fishpay_wx_app_key'),
            'pay_type' =>'wx',
            'notify_url'           => HTTP_SERVER . "payment_callback/fishpay",
            'return_url'           => HTTP_SERVER . 'checkout/success'
		);

		$out_trade_no = trim($order_info['order_id']);
		$subject = trim($this->config->get('config_name'));
        $extra = '';
		$total_amount = round(trim($this->currency->format($order_info['total'], 'CNY', '', false)),2);
        $total_amount = number_format($total_amount,2,".","");
        $unsign = "order_no=" . $out_trade_no . "&subject=" . $subject . "&pay_type=" . $config['pay_type'] . "&money=" . $total_amount . "&app_id=" . $config['app_id'] . "&extra=" . $extra . "&" . $config['app_key'];
        $sign = md5($unsign);
		$payRequestBuilder = array(
			'order_no'         => $out_trade_no,
			'subject'      => $subject,
			'pay_type' => $config['pay_type'],
			'money' => $total_amount,
			'app_id' => $config['app_id'],
            'extra'=>$extra,
            'notify_url'=>$config['notify_url'],
            'return_url'=>$config['return_url'],
            'sign'=>$sign
		);

		$data['action'] = $config['gateway_url'];
		$data['form_params'] = $payRequestBuilder;

		return $this->load->view('extension/payment/fishpay', $data);
	}


}